

ARoots[n_] := Module[{L={},Z,M,i},
		If[n==1,Return[{{1}}]];
		M = ARoots[n-1];
		Z= Array[0 # &,n];
		Z[[1]]=1;
		L=Append[L,Z];
		For[i=1,i<=Length[M],i++,L=Append[L,Prepend[M[[i]],0]];
		If[M[[i]][[1]] != 0,L=Append[L,Prepend[M[[i]],1]]]];
		L]

BRoots[n_] := Module[{L={},i,Z,M},If[n==1,Return[{{1}}]];
		If[n==2,Return[{{1,0},{0,1},{1,1},{1,2}}]];
		M = BRoots[n-1];
		Z= Array[0 # &,n];
		Z[[1]]=1;
		L=Append[L,Z];
		For[i=1,i<=Length[M],i++,L=Append[L,Prepend[M[[i]],0]];
		If[M[[i]][[1]] != 0,L=Append[L,Prepend[M[[i]],1]]];
		If[M[[i]][[2]] == 2,Z=M[[i]];Z[[1]]++;L=Append[L,Prepend[Z,1]]]];
		L]

CRoots[n_] := Module[{L={},i,Z,M},If[n==1,Return[{{1}}]];
		If[n==2,Return[{{1,0},{0,1},{1,1},{2,1}}]];
		M = CRoots[n-1];
		Z= Array[0 # &,n];
		Z[[1]]=1;
		L=Append[L,Z];
		For[i=1,i<=Length[M],i++,L=Append[L,Prepend[M[[i]],0]];		
		If[M[[i]][[1]] != 0,L=Append[L,Prepend[M[[i]],1]]];
		If[M[[i]][[1]] == 2,L=Append[L,Prepend[M[[i]],2]]]];
		L]

DRoots[n_] := Module[{L={},i,Z,M},If[n==1,Return[{{1}}]];
		If[n==2,Return[{{1,0},{0,1}}]];
		If[n==3,Return[{{1,0,0},{0,1,0},{0,0,1},{1,1,0},{1,0,1},{1,1,1}}]];
		If[n==4,Return[{{1,0,0,0},{0,1,0,0},{0,0,1,0},{0,0,0,1},{0,1,1,0},{0,1,0,1},{0,1,1,1},
						{1,1,0,0},{1,1,1,0},{1,1,0,1},{1,1,1,1},{1,2,1,1}}]];
		M = DRoots[n-1];
		Z= Array[0 # &,n];
		Z[[1]]=1;
		L=Append[L,Z];
		For[i=1,i<=Length[M],i++,L=Append[L,Prepend[M[[i]],0]];
		If[M[[i]][[1]] != 0,L=Append[L,Prepend[M[[i]],1]]];
		If[M[[i]][[2]] == 2,Z=M[[i]];Z[[1]]++;L=Append[L,Prepend[Z,1]]]];
		L]
		
E6Roots := Module[{L = {}, M, i, j, Z},
    M = DRoots[5];
    For[i = 1, i <= Length[M], i++,
      Z = M[[i]];
      For[j = 1, j <= 5, j++, M[[i, j]] = Z[[6 - j]]]];
    Z = Array[0 # &, 6];
	Z[[1]] = 1;
	L = Append[L, Z];
    For[i = 1, i <= Length[M], i++, L = Append[L, Prepend[M[[i]], 0]];
      If[M[[i]][[2]] != 0, L = Append[L, Prepend[M[[i]], 1]]]];
      Union[L,{{1,1,2,2,1,0},{1,1,2,2,1,1},{1,1,2,2,2,1},{1,1,2,3,2,1},{1,2,2,3,2,1}}]]
      
E7Roots := Module[{L = {}, M, i, j, Z},
 	M = E6Roots;
 	Z = Array[0 # &, 7];
	Z[[7]] = 1;
	L = Append[L, Z];
	For[i = 1, i <= Length[M], i++, L = Append[L, Append[M[[i]], 0]];
      If[M[[i]][[6]] != 0, L = Append[L, Append[M[[i]], 1]]];
      If[M[[i]][[5]]==2,Z=Append[M[[i]],1];Z[[6]]=2;L=Append[L,Z]]];
    Union[L,{{1,1,2,3,3,2,1},{1,2,2,3,3,2,1},{1,2,2,4,3,2,1},{1,2,3,4,3,2,1},{2,2,3,4,3,2,1}}]]
    
E8Roots := Module[{L = {},W,M, i, j, Z},
 	M = E7Roots;
 	Z = Array[0 # &, 8];
	Z[[8]] = 1;
	L = Append[L, Z];
	For[i = 1, i <= Length[M], i++, L = Append[L, Append[M[[i]], 0]];
      If[M[[i]][[7]] != 0, L = Append[L, Append[M[[i]], 1]]];
      If[M[[i]][[6]]==2,Z=Append[M[[i]],1];Z[[7]]=2;L=Append[L,Z]]];
    W = {{1,1,2,3,3,3,2,1},{1,2,2,3,3,3,2,1},{1,2,2,4,3,3,2,1},{1,2,3,4,3,3,2,1},{1,2,2,4,4,3,2,1},
    {2,2,3,4,3,3,2,1},{1,2,3,4,4,3,2,1},{1,2,3,5,4,3,2,1},{2,2,3,4,4,3,2,1},{1,3,3,5,4,3,2,1},
    {2,2,3,5,4,3,2,1},{2,3,3,5,4,3,2,1},{2,2,4,5,4,3,2,1},{2,3,4,5,4,3,2,1},{2,3,4,6,4,3,2,1},
    {2,3,4,6,5,3,2,1},{2,3,4,6,5,4,2,1},{2,3,4,6,5,4,3,1},{2,3,4,6,5,4,3,2}};
    L=Union[L,W]]
    
ERoots[n_] := If[n==6,E6Roots,If[n==7,E7Roots,E8Roots]]
    
F4Roots := Module[{Z},
		L=ARoots[4];
		Z={{0,1,2,0},{1,1,2,0},{0,1,2,1},{1,2,2,0},{1,1,2,1},{0,1,2,2},{1,2,2,1},{1,1,2,2},
		{1,2,3,1},{1,2,2,2},{1,2,3,2},{1,2,4,2},{1,3,4,2},{2,3,4,2}};
		L=Union[ARoots[4],Z]]
		
G2Roots := {{1,0},{0,1},{1,1},{2,1},{3,1},{3,2}}   

	

 	
 	